#include <stdio.h>
#include "stub_mm.h"
#include "sigscan.h"
#include <windows.h>
#include <detours.h>

using namespace SourceHook;

StubPlugin g_StubPlugin;

#define PASSFILTER "\x53\x56\x57\x8B\xF9\x33\xDB\x33\xF6\x39\x9F"
#define FILTERMASK "xxxxxxxxxxx"
#define FILTERLEN 11

CSigScan PassFilter_Sig;

typedef int (*CountPlayers_t)();
int (*SV_CountPlayers_Orig)( );
int SV_CountPlayers_New();

#define MAXFILTER "\x56\x8B\xF1\x8B\x86\xA4\x01\x00\x00\x8B\x4C"
#define MAXMASK "xxxxxxxxxxx"
#define MAXLEN 11

typedef void (__fastcall *MaxPlayers_t)(char *);
void (__fastcall *SV_SetMaxPlayers)(char *structa);

CSigScan MaxFilter_Sig;

IServerGameDLL *server = NULL;
IServerGameClients *gameclients = NULL;
IVEngineServer *engine = NULL;
IServerPluginHelpers *helpers = NULL;
IServerPluginCallbacks *vsp_callbacks = NULL;
ICvar *icvar = NULL;

ConVar rf_clients("rf_clients", "50", 0);

class BaseAccessor : public IConCommandBaseAccessor
{
public:
	bool RegisterConCommandBase(ConCommandBase *pCommandBase)
	{
		return META_REGCVAR(pCommandBase);
	}
} s_BaseAccessor;

PLUGIN_EXPOSE(StubPlugin, g_StubPlugin);

int SV_CountPlayers_New()
{
	int value = SV_CountPlayers_Orig();
	if(value < rf_clients.GetInt())
		return rf_clients.GetInt();
	return value;
}

bool StubPlugin::Load(PluginId id, ISmmAPI *ismm, char *error, size_t maxlen, bool late)
{
	PLUGIN_SAVEVARS();

	GET_V_IFACE_CURRENT(GetEngineFactory, engine, IVEngineServer, INTERFACEVERSION_VENGINESERVER);
	GET_V_IFACE_CURRENT(GetEngineFactory, helpers, IServerPluginHelpers, INTERFACEVERSION_ISERVERPLUGINHELPERS);
	GET_V_IFACE_CURRENT(GetEngineFactory, icvar, ICvar, CVAR_INTERFACE_VERSION);
	GET_V_IFACE_ANY(GetServerFactory, server, IServerGameDLL, INTERFACEVERSION_SERVERGAMEDLL);
	GET_V_IFACE_ANY(GetServerFactory, gameclients, IServerGameClients, INTERFACEVERSION_SERVERGAMECLIENTS);
	CSigScan::sigscan_dllfunc = ismm->GetEngineFactory(false);
	bool scan = CSigScan::GetDllMemInfo();

	PassFilter_Sig.Init((unsigned char *)PASSFILTER, FILTERMASK, FILTERLEN);
	PassFilter_Sig.base_addr = (unsigned char *)PassFilter_Sig.sig_addr + FILTERLEN;
	PassFilter_Sig.sig_addr = PassFilter_Sig.FindSignature();

	SV_CountPlayers_Orig = (CountPlayers_t)DetourFunction((PBYTE)PassFilter_Sig.sig_addr, (PBYTE)SV_CountPlayers_New);

	/* this would set the maxplayers, but you can't set it when the game is already started, and the maxplayers limit is hardcoded into the engine, you'll crash with more than 96 or so in gmod
	CSigScan::sigscan_dllfunc = ismm->GetEngineFactory(false);
	scan = CSigScan::GetDllMemInfo();
	MaxFilter_Sig.Init((unsigned char *)MAXFILTER, MAXMASK, MAXLEN);
	SV_SetMaxPlayers = (MaxPlayers_t)MaxFilter_Sig.sig_addr;

	char buff2[424];
	*(int *)(buff2 + 0x8) = 64;
	*(int *)(buff2 + 0x1A4) = 64;
	char *buffptr = (char *)&buff2;

	SV_SetMaxPlayers(buffptr);*/

	g_pCVar = icvar;
	ConVar_Register(0, &s_BaseAccessor);

	return true;
}

bool StubPlugin::Unload(char *error, size_t maxlen)
{
	DetourRemove((PBYTE)SV_CountPlayers_Orig, (PBYTE)SV_CountPlayers_New);
	return true;
}

void StubPlugin::AllPluginsLoaded()
{
}

bool StubPlugin::Pause(char *error, size_t maxlen)
{
	return true;
}

bool StubPlugin::Unpause(char *error, size_t maxlen)
{
	return true;
}

const char *StubPlugin::GetLicense()
{
	return "Free";
}

const char *StubPlugin::GetVersion()
{
	return "1.0.0.0";
}

const char *StubPlugin::GetDate()
{
	return __DATE__;
}

const char *StubPlugin::GetLogTag()
{
	return "REALFAKE";
}

const char *StubPlugin::GetAuthor()
{
	return "AzuiSleet";
}

const char *StubPlugin::GetDescription()
{
	return "REAL FAKE CLIENTS";
}

const char *StubPlugin::GetName()
{
	return "FAKE CLIENTS Plugin";
}

const char *StubPlugin::GetURL()
{
	return "http://www.google.com";
}
